<?php
// webtrees: Web based Family History software
// Copyright (C) 2014 Greg Roach
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

use WT\Auth;

/**
 * Class batch_update_WT_Module
 */
class batch_update_WT_Module extends WT_Module implements WT_Module_Config{
	/** {@inheritdoc} */
	public function getTitle() {
		return /* I18N: Name of a module */ WT_I18N::translate('Batch update');
	}

	/** {@inheritdoc} */
	public function getDescription() {
		return /* I18N: Description of the “Batch update” module */ WT_I18N::translate('Apply automatic corrections to your genealogy data.');
	}

	/** {@inheritdoc} */
	public function modAction($mod_action) {
		switch($mod_action) {
		case 'admin_batch_update':
			$controller = new WT_Controller_Page();
			$controller
				->setPageTitle(WT_I18N::translate('Batch update'))
				->restrictAccess(Auth::isAdmin())
				->pageHeader();

			// TODO: these files should be methods in this class
			require WT_ROOT.WT_MODULES_DIR.$this->getName().'/'.$mod_action.'.php';
			$mod=new batch_update;
			echo $mod->main();
			break;
		default:
			header('HTTP/1.0 404 Not Found');
		}
	}

	/** {@inheritdoc} */
	public function getConfigLink() {
		return 'module.php?mod='.$this->getName().'&amp;mod_action=admin_batch_update';
	}
}
